# -*- coding: utf-8 -*-
import os
import sys
import xbmc
import xbmcplugin
import xbmcgui
import urllib
import urllib2
import httplib
try:
    import simplejson as json
except ImportError:
    import json
import gui

__scriptname__  = sys.modules[ '__main__' ].__scriptname__
__scriptID__  = sys.modules[ '__main__' ].__scriptID__
__url__ = sys.modules[ '__main__' ].__url__
__addon__ = sys.modules[ '__main__' ].__addon__
t = sys.modules[ '__main__' ].__language__

checkUrl = __url__ + '/api/checkPluginVersionXBMC'
playerUrl = __url__ + '/api/setPlayer'
jsonUrl = __url__ + '/api/getChannelList'
HOST = 'XBMC'
VERSION = 140

os.path.join( __addon__.getAddonInfo('path'), 'resources' )

SKINS = {
    'confluence': { 'normal': 50, 'list': 512, 'biglist': 51, 'thumbnail': 500 },
    'transparency': { 'normal': 590, 'list': 51, 'biglist': 52, 'thumbnail': 53 }
}

class Settings:
    def __init__(self):
        pass
    
    def showSettings(self):
        __addon__.openSettings(sys.argv[0])
    
    def setViewMode(self, view):
        if view != 'orig':
            for k, v in SKINS.items():
                if k in xbmc.getSkinDir():
                    if view == '4': #Normal
                        xbmc.executebuiltin('Container.SetViewMode(' + str(v['normal']) + ')')
                    elif view == '0': #List
                        xbmc.executebuiltin('Container.SetViewMode(' + str(v['list']) + ')')
                    elif view == '1': #Big list
                        xbmc.executebuiltin('Container.SetViewMode(' + str(v['biglist']) + ')')
                    elif view == '2': #Thumbnail
                        xbmc.executebuiltin('Container.SetViewMode(' + str(v['thumbnail']) + ')')
    
    def getJsonUrl(self):
        return jsonUrl
    
    def checkVersion(self):
        status = None
        try:
            headers = { 'User-Agent' : HOST }
            post = { 'v': VERSION }
            data = urllib.urlencode(post)
            request = urllib2.Request(checkUrl, data, headers)
            response = urllib2.urlopen(request)
            responseRead = response.read()
            parser = UrlParser()
            params = parser.getParams(responseRead)
            status = parser.getIntParam(params, 'status')
        except urllib2.URLError, urlerr:
            print 'Error when checking if the plugin version is up to date!'
            print urlerr
        print 'Version status: %s' % (status)
        return { 'status': status }

class ShowList:
    def __init__(self):
        pass
    
    def decode(self, string):
        json_ustr = json.dumps(string, ensure_ascii=False)
        return json_ustr.encode('utf-8')
    
    def JsonToSortedTab(self, json):
        strTab = []
        outTab = []
        for v,k in json.iteritems():
            strTab.append(int(v))
            strTab.append(k)
            outTab.append(strTab)
            strTab = []
        outTab.sort(key=lambda x: x[0])
        return outTab
    
    def getJsonFromAPI(self, url):
        result_json = { '0': 'Null' }
        try:
            headers = { 'User-Agent': HOST, 'ContentType': 'application/x-www-form-urlencoded' }
            post = { 'username': __addon__.getSetting('username'), 'userpassword': __addon__.getSetting('userpassword') }
            data = urllib.urlencode(post)
            reqUrl = urllib2.Request(url, data, headers)
            raw_json = urllib2.urlopen(reqUrl)
            content_json = raw_json.read()
            result_json = json.loads(content_json)
        except httplib.BadStatusLine, statuserr:
            msg = Messages()
            result_json = { '0': 'Error' }
            print statuserr
            msg.Error(t(57001).encode('utf-8'), t(57002).encode('utf-8'), t(57003).encode('utf-8'))
        except urllib2.URLError, urlerr:
            msg = Messages()
            result_json = { '0': 'Error' }
            print urlerr
            msg.Error(t(57001).encode('utf-8'), t(57002).encode('utf-8'), t(57003).encode('utf-8'))
        except NameError, namerr:
            msg = Messages()
            result_json = { '0': 'Error' }
            print namerr
            msg.Error(t(57009).encode('utf-8'), t(57010).encode('utf-8'))
        except ValueError, valerr:
            msg = Messages()
            result_json = { '0': 'Error' }
            print valerr
            msg.Error(t(57001).encode('utf-8'), t(57011).encode('utf-8'), t(57012).encode('utf-8'), t(57013).encode('utf-8'))
        return result_json
    
    def loadChannels(self, url, listmode):
        parser = UrlParser()
        params = parser.getParams()
        mode = parser.getIntParam(params, 'mode')
        channelsArray = self.JsonToSortedTab(self.getJsonFromAPI(url))
        if len(channelsArray) > 0:
            try:
                if channelsArray[0][1] == 'Null':
                    msg = Messages()
                    msg.Warning(t(57001).encode('utf-8'), t(57004).encode('utf-8'))
                elif channelsArray[0][1] != 'Error' and channelsArray[0][1] != 'Null':
                    for i in range(len(channelsArray)):
                        k = channelsArray[i][1]
                        name = self.decode(k['channel_name']).replace("\"", '')
                        title = self.decode(k['channel_title']).replace("\"", '')
                        desc = self.decode(k['channel_description']).replace("\"", '')
                        tags = self.decode(k['channel_tags']).replace("\"", '')
                        image = k['channel_logo_url']
                        online = k['channel_online']
                        rank = k['rank']
                        bitrate = k['multibitrate']
                        user = self.decode(k['user_name']).replace("\"", '')
                        self.addChannelToXBMC(listmode, str(mode), online, name, title, image, desc, tags, user)
                    s = Settings()
                    s.setViewMode(__addon__.getSetting('channel_list_view'))
                    xbmcplugin.endOfDirectory(int(sys.argv[1]))
                    if mode == 1:
                        xbmcplugin.addSortMethod(handle = int(sys.argv[1]), sortMethod = xbmcplugin.SORT_METHOD_VIDEO_TITLE)
            except KeyError, keyerr:
                msg = Messages()
                print keyerr
                msg.Error(t(57001).encode('utf-8'), t(57025).encode('utf-8'))
        else:
            msg = Messages()
            msg.Error(t(57001).encode('utf-8'), t(57004).encode('utf-8'))
    
    def addChannelToXBMC(self, listmode, mode, online, name, title, img, desc, tags, user):
        status = t(57033).encode('utf-8')
        if title == '':
            title = name
            label = name
        else:
            label = title
        if desc == None or desc == '' or desc == 'null':
            desc = t(57016).encode('utf-8')
        if tags == None or tags == '' or tags == 'null':
            tags = t(57017).encode('utf-8')
        
        if __addon__.getSetting('channel_list_type') == '0':
            if int(online) == 0:
                status = '[COLOR red]' + t(57030).encode('utf-8') + '[/COLOR]'
            elif int(online) == 2:
                status = '[COLOR green]' + t(57029).encode('utf-8') + '[/COLOR]'
            if listmode > 3:
                label = '[B]%s[/B]   [COLOR gray][I]%s [B]%s[/B]  %s [B]%s[/B][/I][/COLOR]    [B]%s[/B]' % (title, t(57031).encode('utf-8'), name, t(57032).encode('utf-8'), user, status)
            else:
                label = '[B]%s[/B]   [COLOR gray][I]%s [B]%s[/B]  %s [B]%s[/B][/I][/COLOR]' % (title, t(57031).encode('utf-8'), name, t(57032).encode('utf-8'), user)
        elif __addon__.getSetting('channel_list_type') == '1':
            if int(online) == 0:
                status = t(57030).encode('utf-8')
            elif int(online) == 2:
                status = t(57029).encode('utf-8')
            if listmode > 3:
                label = '%s %s %s %s %s    %s ' % (title, t(57031).encode('utf-8'), name, t(57032).encode('utf-8'), user, status)
            else:
                label = '%s %s %s %s %s' % (title, t(57031).encode('utf-8'), name, t(57032).encode('utf-8'), user)
        elif __addon__.getSetting('channel_list_type') == '2':
            label = '%s' % (title)
         
        li = xbmcgui.ListItem(label, iconImage = 'DefaultFolder.png', thumbnailImage = img)
        li.setProperty('IsPlayable', 'false')
        li.setInfo(type = 'Video', infoLabels={ 'Title': title, 'Plot': desc, 'Studio': __scriptname__, 'Tagline': tags, 'Status': status, 'Aired': user })
        u = '%s?mode=%d&online=%d&channel=%s&title=%s' % (sys.argv[0], int(mode), int(online), name, urllib.quote_plus(title))
        xbmcplugin.addDirectoryItem(handle = int(sys.argv[1]), url = u, listitem = li, isFolder = False)

class UrlParser:
    def __init__(self):
        pass
    
    def getParam(self, params, name):
        try:
            result = params[name]
            result = urllib.unquote_plus(result)
            return result
        except:
            return None
    
    def getIntParam (self, params, name):
        try:
            param = self.getParam(params, name)
            return int(param)
        except:
            return None
    
    def getBoolParam (self, params, name):
        try:
            param = self.getParam(params,name)
            return 'True' == param
        except:
            return None
    
    def getParams(self, paramstring = sys.argv[2]):
        param=[]
        if len(paramstring) >= 2:
            params = paramstring
            cleanedparams = params.replace('?', '')
            if (params[len(params)-1] == '/'):
                params = params[0:len(params)-2]
            pairsofparams = cleanedparams.split('&')
            param = {}
            for i in range(len(pairsofparams)):
                splitparams = {}
                splitparams = pairsofparams[i].split('=')
                if (len(splitparams)) == 2:
                    param[splitparams[0]] = splitparams[1]
        return param

class VideoPlayer(xbmc.Player):
    def __init__(self, *args, **kwargs):
        self.is_active = True
        print '#Starting control VideoPlayer events#'
    
    def setPremium(self, premium):
        self.premium = premium
    
    def getPremium(self):
        return self.premium
    
    def onPlayBackPaused(self):
        print '#Im paused#'
        self.is_active = False
    
    def onPlayBackResumed(self):
        print '#Im Resumed #'
    
    def onPlayBackStarted(self):
        print '#Playback Started#'
        self.is_active = True
        self.tryreconnect_count = 0
        try:
            print '#Im playing :: ' + self.getPlayingFile()
        except:
            print '#I failed get what Im playing#'
    
    def onPlayBackEnded(self):
        msg = Messages()
        print '#Playback Ended#'
        self.is_active = False
        if self.getPremium() == 0:
            msg.Warning(t(57018).encode('utf-8'), t(57019).encode('utf-8'), t(57020).encode('utf-8'))
        else:
            if __addon__.getSetting('video_autoreconnect') == 'true':
                self.sleep(500)
                if self.tryreconnect_count < 2:
                    self.tryreconnect_count = self.tryreconnect_count+1
                    self.LoadVideoLink(self.channel)
            else:
                msg.Warning(t(57018).encode('utf-8'), t(57027).encode('utf-8'))
    
    def onPlayBackStopped(self):
        print '## Playback Stopped ##'
        self.is_active = False
    
    def sleep(self, s):
        xbmc.sleep(s)
    
    def setPlayer(self, channel):
        status = None
        rtmp = None
        imgLink = None
        titile = ''
        premium = 0
        try:
            if __addon__.getSetting('username') != '' and __addon__.getSetting('userpassword') != '':
                post = { 'platform': HOST, 'channel': channel, 'username': __addon__.getSetting('username'), 'userpassword': __addon__.getSetting('userpassword') }
            else:
                post = { 'platform': HOST, 'channel': channel }
            data = urllib.urlencode(post)
            headers = { 'User-Agent' : HOST }
            request = urllib2.Request(playerUrl, data, headers)
            response = urllib2.urlopen(request)
            responseRead = response.read()
            parser = UrlParser()
            params = parser.getParams(responseRead)
            
            status = parser.getParam(params, '0')
            premium = parser.getIntParam(params, '5')
            imgLink = parser.getParam(params, '8')
            rtmpLink = parser.getParam(params, '10')
            playPath = parser.getParam(params, '11')
            bitrate = parser.getIntParam(params, '20')
            token = parser.getParam(params, '73')
            title = parser.getParam(params, '6')
            if title == '':
                 title = parser.getParam(params, '7')
            if __addon__.getSetting('video_quality') == '2' and bitrate == 1:
                playPath = playPath + 'HI'
            elif __addon__.getSetting('video_quality') == '0' and bitrate == 2:
                playPath = playPath + 'LOW'
            
            rtmp = str(rtmpLink) + '/' + str(playPath) + ' live=true pageUrl=token swfUrl=' + str(token)
        except urllib2.URLError, urlerr:
            print urlerr
            msg = Messages()
            msg.Error(t(57014).encode('utf-8'), t(57015).encode('utf-8'), t(57003).encode('utf-8'))
        print 'Output rtmp link: %s' % (rtmp)
        return { 'status': status, 'rtmp': rtmp, 'imgLink': imgLink, 'title': title, 'premium': premium }
    
    def LoadVideoLink(self, channel):
        self.channel = channel
        res = True
        videoLink = self.setPlayer(channel)             
        if videoLink['status'] == '1':
            if videoLink['rtmp'].startswith('rtmp'):
                li = xbmcgui.ListItem(videoLink['title'], iconImage = videoLink['imgLink'], thumbnailImage = videoLink['imgLink'])
                li.setInfo(type='Video', infoLabels={ 'Title': videoLink['title'] })
                try:
                    self.setPremium(int(videoLink['premium']))
                    if videoLink['premium'] == 0:
                        msg = Messages()
                        msg.Warning(t(57034).encode('utf-8'), t(57036).encode('utf-8'), t(57037).encode('utf-8'), t(57038).encode('utf-8'))
                    self.play(videoLink['rtmp'], li)
                    while self.is_active:
                        self.sleep(100)
                except:
                    msg = Messages()
                    msg.Error(t(57018).encode('utf-8'), t(57021).encode('utf-8'))
            else:
                msg = Messages()
                msg.Error(t(57018).encode('utf-8'), t(57022).encode('utf-8'))
        elif videoLink['status'] == '-1':
            msg = Messages()
            msg.Warning(t(57018).encode('utf-8'), t(57043).encode('utf-8'))
        elif videoLink['status'] == '-2':
            msg = Messages()
            msg.Warning(t(57018).encode('utf-8'), t(57044).encode('utf-8')) 
        elif videoLink['status'] == '-3':
            msg = Messages()
            msg.Warning(t(57018).encode('utf-8'), t(57045).encode('utf-8'))
        elif videoLink['status'] == '-4':
            msg = Messages()
            msg.Warning(t(57018).encode('utf-8'), t(57046).encode('utf-8'), t(57047).encode('utf-8'))
        else:
            msg = Messages()
            msg.Warning(t(57018).encode('utf-8'), t(57042).encode('utf-8'))
        return res

class Messages:
    def __init__(self):
        pass
    
    def Error(self, t1, t2, t3 = '', t4 = ''):
        err = gui.Windows()
        err.Error(t1, t2, t3, t4)
    
    def Warning(self, t1, t2, t3 = '', t4 = ''):
        warn = gui.Windows()
        warn.Warning(t1, t2, t3, t4)

class Handler:
    def __init__(self):
        pass
    
    def run(self, mode):
        parser = UrlParser()
        params = parser.getParams()
        mode = parser.getIntParam(params, 'mode')
        channel = parser.getParam(params, 'channel')
        title = parser.getParam(params, 'title')
        online = parser.getIntParam(params, 'online')
        if mode > 0 and online == None:
            url = ''
            if mode == 1:
                url = jsonUrl + '&option=online-alphabetical'
            elif mode == 2:
                url = jsonUrl + '&option=online-now-viewed'
            elif mode == 3:
                url = jsonUrl + '&option=online-most-viewed'
            elif mode == 4:
                url = jsonUrl + '&option=offline-ranking'
            elif mode == 5:
                url = jsonUrl + '&option=all-ranking'
            showlist = ShowList()
            showlist.loadChannels(url, mode)
        elif mode > 0 and online == 2:
            if channel != '':
                run = VideoPlayer()
                run.LoadVideoLink(channel)
        elif mode > 0 and online == 0:
            msg = Messages()
            msg.Warning(t(57005).encode('utf-8'), t(57006).encode('utf-8'), t(57007).encode('utf-8'))
